<?php

//------------------------------------
//   Logout Redirect Extension
//   using 'member_member_logout' hook
//   author: Mark Bowen
//------------------------------------

	if ( ! defined('EXT'))
	{
		exit('Invalid file request');
	}

	class Logout_redirect
	{
		var $settings = array();
		var $name = 'Logout Redirect';
		var $classname = 'Logout_redirect';
		var $version = '1.2';
		var $description = 'This extension works in conjunction with the pi.logout_redirect.php plugin to provide a way of re-directing users upon logging out of the system.';
		var $settings_exist = 'n';
		var $docs_url = '';
		
		
		//------------------------------------
		//   Constructor - Settings
		//------------------------------------
		
		/*function Logout_redirect($settings='')
		{
			$this->settings = $settings;
		}*/
		
		// END
		
		
		//------------------------------------
		//  Activate Extension
		//------------------------------------
		
		function activate_extension()
		{
			global $DB;
					
			$DB->query($DB->insert_string('exp_extensions',
					array(
					'extension_id'	=> '',
					'class'			=> $this->classname,
					'method'		=> "redirect_upon_logout",
					'hook'			=> "member_member_logout",
//					'settings'		=> $default_settings,
					'settings'		=> "",
					'priority'		=> 10,
					'version'		=> $this->version,
					'enabled'		=> "y"
					)
				)
			);
			
	
			$DB->query("CREATE TABLE IF NOT EXISTS `exp_logout_redirect_url` (
						`member_id` INT( 10 ) NULL ,
						`redirect_url` MEDIUMTEXT NULL ,
						PRIMARY KEY (`member_id`));"
			);
			
			// foreach ($sql as $query)
				// {
					// $DB->query($query);
				// }
					
			// return true;
			
		}
		
		// END
		
		
		
		// --------------------------------
		//  Disable Extension
		// --------------------------------
		
		function disable_extension()
		{
			global $DB;
		
			$DB->query("DELETE FROM exp_extensions WHERE class = 'Logout_redirect'");
			$DB->query("DROP TABLE exp_logout_redirect_url;");
		}
		
		// END
		
		
		//------------------------------------
		//  Update Extension
		//------------------------------------
		
		function update_extension($current='')
		{
			global $DB;
			
			if ($current == '' OR $current == $this->version)
			{
				return FALSE;
			}
			
			if ($current > '1.0')
			{
				// Update to next version
			}
			
			$DB->query("UPDATE exp_extensions 
						SET version = '".$DB->escape_str($this->version)."' 
						WHERE class = '$this->classname'");
		}
		// END
		
		
			
		// --------------------------------
		//  Settings
		// --------------------------------  
		
		function settings()
		{
			$settings = array();
			$settings['redirect_url']    = "";
						
			return $settings;
		}

		// END
	

	
		//------------------------------------
		//   Logout Redirect Function
		//------------------------------------
		
		function redirect_upon_logout()
		{
			global $DB, $FNS, $EXT, $SESS, $PREFS;
			
		//------------------------------------
		//   Find the URL to redirect to
		//------------------------------------
	
		$member_id = $SESS->userdata['member_id'];
		$query = $DB->query("SELECT * FROM exp_logout_redirect_url WHERE member_id = '$member_id'");
	
		if ($query->num_rows > 0)
		{
			foreach($query->result as $row)
			{
				$redirect_url = $row['redirect_url'];
			}
		}
			
			
		//----------------------------------------
		//	Perform the redirect with the value
		//	taken from the database table
		//----------------------------------------
	
		$FNS->redirect($redirect_url);
		// $EXT->end_script = TRUE;
			
	   }
	   
	   // END
	
}
?>