<?php

/*
=============================================================
	eeFlickr Module for EllisLab ExpressionEngine
	- by David Rencher
-------------------------------------------------------------
	http://www.lumis.com/
-------------------------------------------------------------
	Copyright (c) 2007 - 2008 David Rencher
=============================================================
	 THIS IS COPYRIGHTED SOFTWARE
-------------------------------------------------------------
	This software is based upon and derived from
	EllisLab ExpressionEngine software protected under
	copyright dated 2004 - 2007. Please see
	www.expressionengine.com/docs/license.html
=============================================================
	File:			mod.eeflickr.php
-------------------------------------------------------------
	Compatibility:	EE 1.6 + php cURL
-------------------------------------------------------------
	Purpose:		Flickr API Methods for ExpressionEngine
=============================================================
*/



if ( ! defined('EXT'))
{
    exit('Invalid file request');
}


class eeflickr {

	var $resturl		= 'http://api.flickr.com/services/rest/';
	var $cache_path     = 'eeFlickr_cache25/';
	var $fdata 			= '';
	var $method 		= '';
	


/*
Tag: exp:eeflickr:photosets_getPhotos
method: flickr.photosets.getPhotos
*/	
function photosets_getPhotos(){
		global $LOC, $TMPL, $FNS, $DSP;
		$tagdata = "";
		$this->method = "flickr.photosets.getPhotos";
		
		/**	----------------------------------------
		/**	 get data from flickr REST
		/**	----------------------------------------*/
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$TMPL->tagparams)));
			// fail if flickr is not ok with what you asked for 
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}
			
			
		/**	----------------------------------------
		/**	 prep Flickr Data
		/**	----------------------------------------*/	
    		// prep photo loop
			$thedata = $this->fdata['photoset']['photo'];

			// prep pageing data
			$pagedata['1'] = array(
				'page' => $this->fdata['photoset']['page'],
				'pages' => $this->fdata['photoset']['pages'],
				'perpage' => $this->fdata['photoset']['per_page'],
				'total' => $this->fdata['photoset']['total'],
				);
		
		/**	----------------------------------------
		/**	 parse eeflickr:photos pair
		/**	----------------------------------------*/
			if(!$thedata)
			{
			return $TMPL->no_results();
			}
		$tagdata = $this->doPair($TMPL->tagdata,$thedata,'eeflickr:photosets_getPhotos_loop');
		
		/**	----------------------------------------
		/**	 parse eeflickr:photos_paging pair
		/**	----------------------------------------*/
		$tagdata = $this->doPair($tagdata,$pagedata,'eeflickr:photosets_getPhotos_paging');
			
		return $tagdata;
}// end exp:eeflickr:photosets_getPhotos




/*
Tag: exp:eeflickr:photos_getWithGeoData
method: flickr.photos.search
*/	
function photos_getWithGeoData(){
		global $LOC, $TMPL, $FNS, $DSP;
		$tagdata = "";
		$this->method = "flickr.photos.getWithGeoData";
		
		/**	----------------------------------------
		/**	 get data from flickr REST
		/**	----------------------------------------*/
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$TMPL->tagparams)));
			// fail if flickr is not ok with what you asked for 
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}

			
		/**	----------------------------------------
		/**	 prep Flickr Data
		/**	----------------------------------------*/	
    		// prep photo loop
			$thedata = $this->fdata['photos']['photo'];

			// prep pageing data
			$pagedata['1'] = array(
				'page' => $this->fdata['photos']['page'],
				'pages' => $this->fdata['photos']['pages'],
				'perpage' => $this->fdata['photos']['perpage'],
				'total' => $this->fdata['photos']['total'],
				);
		
		/**	----------------------------------------
		/**	 parse eeflickr:photos pair
		/**	----------------------------------------*/
			if(!$thedata)
			{
			return $TMPL->no_results();
			}
		$tagdata = $this->doPair($TMPL->tagdata,$thedata,'eeflickr:photos_getWithGeoData_loop');
		
		/**	----------------------------------------
		/**	 parse eeflickr:photos_paging pair
		/**	----------------------------------------*/
		$tagdata = $this->doPair($tagdata,$pagedata,'eeflickr:photos_getWithGeoData_paging');
			
		return $tagdata;
}// end exp:eeflickr:photos_getWithGeoData

	

/*
Tag: exp:eeflickr:photos_search
method: flickr.photos.search
*/	
function photos_search(){
		global $LOC, $TMPL, $FNS, $DSP;
		$tagdata = "";
		$this->method = "flickr.photos.search";
		
		/**	----------------------------------------
		/**	 get data from flickr REST
		/**	----------------------------------------*/
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$TMPL->tagparams)));
			// fail if flickr is not ok with what you asked for 
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}
			
		/**	----------------------------------------
		/**	 prep Flickr Data
		/**	----------------------------------------*/	
    		// prep photo loop
			$thedata = $this->fdata['photos']['photo'];
			
			// prep pageing data
			$pagedata['1'] = array(
				'page' => $this->fdata['photos']['page'],
				'pages' => $this->fdata['photos']['pages'],
				'perpage' => $this->fdata['photos']['perpage'],
				'total' => $this->fdata['photos']['total'],
				);
		
		/**	----------------------------------------
		/**	 parse eeflickr:photos pair
		/**	----------------------------------------*/
			if(!$thedata)
			{
			return $TMPL->no_results();
			}
		$tagdata = $this->doPair($TMPL->tagdata,$thedata,'eeflickr:photos_search_loop');
		
		/**	----------------------------------------
		/**	 parse eeflickr:photos_paging pair
		/**	----------------------------------------*/
		$tagdata = $this->doPair($tagdata,$pagedata,'eeflickr:photos_search_paging');
			
		return $tagdata;
}// end exp:eeflickr:photos



/*
Tag: exp:eeflickr:photos_getContext
method: flickr.photos.getContext
*/	
function photos_getContext(){
		global $LOC, $TMPL, $FNS, $DSP;
		$tagdata = "";
		$this->method = "flickr.photos.getContext";
		
		/**	----------------------------------------
		/**	 get data from flickr REST
		/**	----------------------------------------*/
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$TMPL->tagparams)));
			// fail if flickr is not ok with what you asked for 
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}

		/**	----------------------------------------
		/**	 prep Flickr Data
		/**	----------------------------------------*/	
			$thedata = array();
			foreach($this->fdata as $item => $array)
			{
				if(is_array($array))
					{
					foreach($array as $key => $value)
						{
						 	$thedata[$item."_".$key] = $value;
						}
				}
			}
		
		/**	----------------------------------------
		/**	 parse single vars
		/**	----------------------------------------*/
		  $tagdata = $this->doSingle($TMPL->tagdata,$thedata);
			
	return $tagdata;
}// end exp:eeflickr:photos_getContext



/*
Tag: exp:eeflickr:photosets_getContext
method: flickr.photosets.getContext
*/	
function photosets_getContext(){
		global $LOC, $TMPL, $FNS, $DSP;
		$tagdata = "";
		$this->method = "flickr.photosets.getContext";
		
		/**	----------------------------------------
		/**	 get data from flickr REST
		/**	----------------------------------------*/
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$TMPL->tagparams)));
			// fail if flickr is not ok with what you asked for 
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}

		/**	----------------------------------------
		/**	 prep Flickr Data
		/**	----------------------------------------*/	
			$thedata = array();
			foreach($this->fdata as $item => $array)
			{
				if(is_array($array))
					{
					foreach($array as $key => $value)
						{
						 	$thedata[$item."_".$key] = $value;
						}
				}
			}
		
		/**	----------------------------------------
		/**	 parse single vars
		/**	----------------------------------------*/
		  $tagdata = $this->doSingle($TMPL->tagdata,$thedata);
			
	return $tagdata;
}// end exp:eeflickr:photosets_getContext



/*
Tag: exp:eeflickr:photosets_getInfo
method: flickr.photosets.getInfo
*/	
function photosets_getInfo(){
		global $LOC, $TMPL, $FNS, $DSP;
		$tagdata = "";
		$this->method = "flickr.photosets.getInfo";
		
		/**	----------------------------------------
		/**	 get data from flickr REST
		/**	----------------------------------------*/
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$TMPL->tagparams)));
			// fail if flickr is not ok with what you asked for 
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}
           
		/**	----------------------------------------
		/**	 prep Flickr Data
		/**	----------------------------------------*/	
			  $thedata = array();
					foreach($this->fdata['photoset'] as $key => $value)
						{
							// make a few extra tags for cleaned text
							if($key == "description")
							{
							   $thedata["description_alt"] = $this->alttext($value);
							   $thedata["description_clean"] = $this->cleantext($value);
							   $thedata["description_br"] = nl2br($value);
							}
							if($key == "title")
							{
							 $thedata["url_title"] = str_replace(" ", "_", $value);
							}
						$thedata[$key] = $value;
						}

		/**	----------------------------------------
		/**	 parse single vars
		/**	----------------------------------------*/	
		  $tagdata = $this->doSingle($TMPL->tagdata,$thedata);
			
	return $tagdata;
}// end exp:eeflickr:photosets_getInfo



/*
Tag: exp:eeflickr:photosets_getList
method: flickr.photosets.getList
*/	
function photosets_getList(){
		global $LOC, $TMPL, $FNS, $DSP;
		$tagdata = "";
		$this->method = "flickr.photosets.getList";
		
		/**	----------------------------------------
		/**	 get data from flickr REST
		/**	----------------------------------------*/
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$TMPL->tagparams)));
			// fail if flickr is not ok with what you asked for 
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}
           //print_r($this->fdata);

		/**	----------------------------------------
		/**	 prep Flickr Data
		/**	----------------------------------------*/	
			$thedata = array();
			$i=0;
			foreach($this->fdata['photosets']['photoset'] as $item)	{
			  $thedata = array();
					foreach($item as $key => $value)
						{
							// make a few extra tags for cleaned text
							if($key == "description")
							{
							   $thedata["description_alt"] = $this->alttext($value);
							   $thedata["description_clean"] = $this->cleantext($value);
							   $thedata["description_br"] = nl2br($value);
							}
							if($key == "title")
							{
							 $thedata["url_title"] = str_replace(" ", "_", $value);
							}
						$thedata[$key] = $value;
						}
			$setdata[$i++] = $thedata;
			}

		
		/**	----------------------------------------
		/**	 parse single vars
		/**	----------------------------------------*/	
		  $tagdata = $this->doLoop($TMPL->tagdata,$setdata);
			
	return $tagdata;
}// end exp:eeflickr:photosets_getList



/*
Tag: exp:eeflickr:tags_getListUserPopular
method: flickr.tags.getListUserPopular
*/	
function tags_getListUserPopular(){
		global $LOC, $TMPL, $FNS, $DSP;
		$tagdata = "";
		$this->method = "flickr.tags.getListUserPopular";
				
		$sort = ( $TMPL->fetch_param('sort') ) ? $TMPL->fetch_param('sort'): 'alpha-desc';
		
		$min_size = ( $TMPL->fetch_param('min_size') ) ? $TMPL->fetch_param('min_size'): '8';
		
		$max_size = ( $TMPL->fetch_param('max_size') ) ? $TMPL->fetch_param('max_size'): '24';
		
		$color_offset = ( $TMPL->fetch_param('color_offset') ) ? $TMPL->fetch_param('color_offset'): '20';
				
		$mincount = ( $TMPL->fetch_param('mincount') ) ? $TMPL->fetch_param('mincount'): '2';
		
		$ignore = ( $TMPL->fetch_param('ignore') ) ? $TMPL->fetch_param('ignore'): '';
		/**	----------------------------------------
		/**	 get data from flickr REST
		/**	----------------------------------------*/
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$TMPL->tagparams)));
			// fail if flickr is not ok with what you asked for 
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}

		/**	----------------------------------------
		/**	 prep Flickr Data
		/**	----------------------------------------*/	

			foreach ($this->fdata['who']['tags']['tag'] as $tag)
			{
				$tagscounted[$tag['_content']] = $tag['count'];
			}

		/**	----------------------------------------
		/**	 Prep the Ignored Tags List
		/**	----------------------------------------*/
		$ignore = str_replace("&#47;", "/", $ignore);
			if($ignore){
				$tagstoignore = explode("|",$ignore);
			}ELSE{
				$tagstoignore[] = "";
			}
			
		/**	----------------------------------------
		/**	 Prep sorting options
		/**	----------------------------------------*/
  		$tags_max = max($tagscounted);

			// sort options
			if($sort === "count-desc"){arsort($tagscounted);}
			if($sort === "count-asc"){asort($tagscounted);}
			if($sort === "alpha-desc"){ksort($tagscounted);}
			if($sort === "alpha-asc"){krsort($tagscounted);}


		/**	----------------------------------------
		/**	 Prep for Out
		/**	----------------------------------------*/	 
			foreach ($tagscounted as $key => $value) {
				 
					if (! in_array($key, $tagstoignore) && $value > $mincount) {
					$font_size = ($max_size-$min_size)*(sqrt($value/$tags_max))+$min_size;
					
					$font_color = 255-ceil((255-$color_offset)*(sqrt($value/$tags_max))+$color_offset);
					$color_low = 255 - $font_color;
					
							$thedata[] = array(
								"tag" => $key,
								"tag_count" => $value,
								"font_size" => $font_size,
								"color_low"=>$color_low,
								"color_hi"=>$font_color,
							 );
					}
			}

		
		/**	----------------------------------------
		/**	 parse single vars
		/**	----------------------------------------*/	
		  $tagdata = $this->doLoop($TMPL->tagdata,$thedata);
			
	return $tagdata;
}// end exp:eeflickr:tags_getListUserPopular



/*
Tag: exp:eeflickr:photos_getSizes
method: flickr.photos.getSizes
*/	
function photos_getSizes(){
		global $LOC, $TMPL, $FNS, $DSP;
		$tagdata = "";
		$this->method = "flickr.photos.getSizes";
		
		/**	----------------------------------------
		/**	 get data from flickr REST
		/**	----------------------------------------*/
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$TMPL->tagparams)));
			// fail if flickr is not ok with what you asked for 
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}

		/**	----------------------------------------
		/**	 prep Flickr Data
		/**	----------------------------------------*/	
			$thedata = array();
			foreach($this->fdata['sizes']['size'] as $size)
			{
			$labele = $size['label'];
				foreach($size as $key => $value)
				{
				 $thedata["photo_".$labele."_".$key] = $value;
					$var = "photo_".$labele."_".$key;
					$$var = $value;
				}
			}

		/**	----------------------------------------
		/**	 parse single vars
		/**	----------------------------------------*/	
		  $tagdata = $this->doSingle($TMPL->tagdata,$thedata);
			
	return $tagdata;
}// end exp:eeflickr:photos_getSizes





/*
Tag: exp:eeflickr:tags_getListUserRaw
method: flickr.tags_getListUserRaw
*/	
function tags_getListUserRaw(){
		global $LOC, $TMPL, $FNS, $DSP;
		$tagdata = "";
		$this->method = "flickr.tags.getListUserRaw";
		$ignore = ( $TMPL->fetch_param('ignore') ) ? $TMPL->fetch_param('ignore'): '';
		
		/**	----------------------------------------
		/**	 get data from flickr REST
		/**	----------------------------------------*/
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$TMPL->tagparams)));
			// fail if flickr is not ok with what you asked for 
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}
			
		/**	----------------------------------------
		/**	 prep Flickr Data
		/**	----------------------------------------*/	
    		// prep tags loop
			$inputdata = $this->fdata['who']['tags']['tag'];
			
		/**	----------------------------------------
		/**	 Prep the Ignored Tags List
		/**	----------------------------------------*/
		$ignore = str_replace("&#47;", "/", $ignore);
			if($ignore){
				$tagstoignore = explode("|",$ignore);
			}ELSE{
				$tagstoignore[] = "";
			}
			
		/**	----------------------------------------
		/**	 Build Vars List
		/**	----------------------------------------*/
			foreach($inputdata as $tag){
			   if (! in_array($tag['clean'], $tagstoignore)) 
				  {
				$lumis_url = str_replace('/', '^', $tag['raw']['0']);
				$lumis_url = str_replace(' ', '_', $lumis_url);
					$thedata[] = array(
							'clean' => $tag['clean'],
							'raw' => $tag['raw']['0'],
							'url_raw' => urlencode($tag['raw']['0']),
							'lumis_url' => $lumis_url,			
							);
					}
			}
		
		/**	----------------------------------------
		/**	 parse to template
		/**	----------------------------------------*/
		$tagdata = $this->doLoop($TMPL->tagdata,$thedata);
			
		return $tagdata;
}// end exp:eeflickr:tags_getListUserRaw




/*
Tag: exp:eeflickr:tags_getListPhoto
method: flickr.tags.getListPhoto
*/	
function tags_getListPhoto(){
		global $LOC, $TMPL, $FNS, $DSP;
		$tagdata = "";
		$this->method = "flickr.tags.getListPhoto";
		$ignore = ( $TMPL->fetch_param('ignore') ) ? $TMPL->fetch_param('ignore'): '';
		
		/**	----------------------------------------
		/**	 get data from flickr REST
		/**	----------------------------------------*/
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$TMPL->tagparams)));
			// fail if flickr is not ok with what you asked for 
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}
			if(! $this->fdata['photo']['tags']['tag'])
			{
			return;
			}
			
		/**	----------------------------------------
		/**	 prep Flickr Data
		/**	----------------------------------------*/	
    		// prep tags loop
			$inputdata = $this->fdata['photo']['tags']['tag'];
			
		/**	----------------------------------------
		/**	 Prep the Ignored Tags List
		/**	----------------------------------------*/
		$ignore = str_replace("&#47;", "/", $ignore);
			if($ignore){
				$tagstoignore = explode("|",$ignore);
			}ELSE{
				$tagstoignore[] = "";
			}
			

		/**	----------------------------------------
		/**	 Build Vars List
		/**	----------------------------------------*/
			foreach($inputdata as $tag){
			   if (! in_array($tag['_content'], $tagstoignore)) 
				  {
					$lumis_url = str_replace('/', '^', $tag['raw']);
					$lumis_url = str_replace(' ', '_', $lumis_url);
					
						$www = "www";
				
						$thedata[] = array(
								'id' => $tag['id'],
								'author' => $tag['author'],
								'authorname' => $tag['authorname'],
								"www_url" => $www,
								'raw' => $tag['raw'],
								'clean' => $tag['_content'],
								'machine_tag' => $tag['machine_tag'],
								'url_raw' => urlencode($tag['raw']),
								'lumis_url' => $lumis_url,			
						);
				 } 
			}
		
		/**	----------------------------------------
		/**	 parse to template
		/**	----------------------------------------*/
		$tagdata = $this->doLoop($TMPL->tagdata,$thedata);
			
		return $tagdata;
}// end exp:eeflickr:tags_getListPhoto



/*
Tag: exp:eeflickr:photos_getInfo
method: flickr.photos.getInfo
*/	
function photos_getInfo(){
		global $LOC, $TMPL, $FNS, $DSP;
		$tagdata = "";
		$this->method = "flickr.photos.getInfo";
		
		/**	----------------------------------------
		/**	 get data from flickr REST
		/**	----------------------------------------*/
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$TMPL->tagparams)));
			// fail if flickr is not ok with what you asked for 
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}
			//print_r($this->fdata);
			
		/**	----------------------------------------
		/**	 prep Flickr Data
		/**	----------------------------------------*/	

			$inputdata = $this->fdata['photo'];

			foreach($inputdata as $key=>$var){
 
				   if(!is_array($var)){
					   $thedata[$key] = $var;
			   
					   
					   if($key == "title"){
						   $thedata["title_amp"] = str_replace("&", "&amp;", $var);
						   $thedata["title_url"] = $this->alttext(str_replace(" ", "_", $var));
					   }
		
					   if($key == "description"){
						   $thedata["description_alt"] = $this->alttext($var);
						   $thedata["description_clean"] = $this->cleantext($var);
						   $thedata["description_br"] = nl2br($var);
					   }
					   
				   
				   }ELSE{
						 foreach($var as $item=>$thing)
						 {
							 if(!is_array($thing))
							 {
								 $thedata[$item] = $thing;
							 }
						 }
				   }
			}

		
		// prep Location names
		if(isset($inputdata['location']))
		{			
			$local = $inputdata['location'];
			//print_r($local);
			foreach($local as $key=>$var)
			{
					if(!is_array($key))
					 {
						 $thedata[$key] = $var['_content'];
					 }
					if(!is_array($var))
					 {
					 $thedata[$key] = $var;
					 }
			}
		}
		
		// prep notes
		$notes = $inputdata['notes']['note'];


		
		/**	----------------------------------------
		/**	 parse to template
		/**	----------------------------------------*/
		$tagdata = $this->doPair($TMPL->tagdata,$notes,'eeflickr:photos_getInfo_notes');
		//$tagdata = $this->doPair($tagdata,$tags,'eeflickr:photos_getInfo_tags');
		$tagdata = $this->doSingle($tagdata,$thedata);
			
		return $tagdata;
}// end exp:eeflickr:photos_getInfo



/*
Tag: exp:eeflickr:comments_getList
method: flickr.photos.comments.getList
*/	
function comments_getList(){
		global $LOC, $TMPL, $FNS, $DSP;
		$tagdata = "";
		$this->method = "flickr.photos.comments.getList";
		
		/**	----------------------------------------
		/**	 get data from flickr REST
		/**	----------------------------------------*/
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$TMPL->tagparams)));
			// fail if flickr is not ok with what you asked for 
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}
			if(!key_exists('comment', $this->fdata['comments']))
			{
				return;
			}

		/**	----------------------------------------
		/**	 prep Flickr Data
		/**	----------------------------------------*/	
			$thedata = array();
			$i=0;
			foreach($this->fdata['comments']['comment'] as $item)	{
			  $thedata = array();
					foreach($item as $key => $value)
						{
							// make a few extra tags for cleaned text
							if($key == "_content")
							{
							   $thedata["comment"] = $this->cleantext($value);
							   $thedata["comment_clean"] = $this->cleantext($value);
							   $thedata["comment_br"] = nl2br($value);
							   $thedata["comment_nofollow"] = $this->rel_nofollow($value);
							}
						$thedata[$key] = $value;
						}
			$commentdata[$i++] = $thedata;
			}

		/**	----------------------------------------
		/**	 parse single vars
		/**	----------------------------------------*/	
		  $tagdata = $this->doLoop($TMPL->tagdata,$commentdata);
			
	return $tagdata;
}// end exp:eeflickr:comments_getList




/*
Tag: exp:eeflickr:people_getInfo
method: flickr.people.getInfo
*/	
function people_getInfo(){
		global $LOC, $TMPL, $FNS, $DSP;
		$tagdata = "";
		$this->method = "flickr.people.getInfo";
		
		/**	----------------------------------------
		/**	 get data from flickr REST
		/**	----------------------------------------*/
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$TMPL->tagparams)));
			// fail if flickr is not ok with what you asked for 
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}

		/**	----------------------------------------
		/**	 prep Flickr Data
		/**	----------------------------------------*/
			
			$thedata = array();
					foreach($this->fdata['person'] as $key => $value)
						{
							if(!is_array($value)){
								$thedata[$key] = $value;
							}
						}
					foreach($this->fdata['person']['photos'] as $key => $value)
						{
						$thedata[$key] = $value;
						}

		/**	----------------------------------------
		/**	 parse single vars
		/**	----------------------------------------*/	
		  $tagdata = $this->doSingle($TMPL->tagdata,$thedata);
			
	return $tagdata;
}// end exp:eeflickr:people_getInfo





/*
Tag: exp:eeflickr:favorites_getList
method: flickr.favorites.getList
*/	
function favorites_getList(){
		global $LOC, $TMPL, $FNS, $DSP;
		$tagdata = "";
		$this->method = "flickr.favorites.getList"; 
		
		/**	----------------------------------------
		/**	 get data from flickr REST
		/**	----------------------------------------*/
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$TMPL->tagparams)));
			// fail if flickr is not ok with what you asked for 
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}
			if(!key_exists('photo', $this->fdata['photos']))
			{
				return;
			}
			
		/**	----------------------------------------
		/**	 prep Flickr Data
		/**	----------------------------------------*/	
    		// prep photo loop
			$thedata = $this->fdata['photos']['photo'];
			//print_r($thedata);
			// prep pageing data
			$pagedata['1'] = array(
				'page' => $this->fdata['photos']['page'],
				'pages' => $this->fdata['photos']['pages'],
				'perpage' => $this->fdata['photos']['perpage'],
				'total' => $this->fdata['photos']['total'],
				);
		
		/**	----------------------------------------
		/**	 parse eeflickr:photos pair
		/**	----------------------------------------*/
			if(!$thedata)
			{
			return $TMPL->no_results();
			}
		$tagdata = $this->doPair($TMPL->tagdata,$thedata,'eeflickr:favorites_getList_loop');
		
		/**	----------------------------------------
		/**	 parse eeflickr:photos_paging pair
		/**	----------------------------------------*/
		$tagdata = $this->doPair($tagdata,$pagedata,'eeflickr:favorites_getList_paging');
			
		return $tagdata;
}// end exp:eeflickr:favorites_getList



/*
Tag: exp:eeflickr:contacts_getPublicList
method: flickr.contacts.getPublicList
*/	
function contacts_getPublicList(){
		global $LOC, $TMPL, $FNS, $DSP;
		$tagdata = "";
		$this->method = "flickr.contacts.getPublicList";
		
		/**	----------------------------------------
		/**	 get data from flickr REST
		/**	----------------------------------------*/
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$TMPL->tagparams)));
			// fail if flickr is not ok with what you asked for 
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}
			if(!key_exists('contact', $this->fdata['contacts']))
			{
				return;
			}
			
		/**	----------------------------------------
		/**	 prep Flickr Data
		/**	----------------------------------------*/	
    		// prep photo loop
			$thedata = $this->fdata['contacts']['contact'];
			//print_r($thedata);
			// prep pageing data
			$pagedata['1'] = array(
				'page' => $this->fdata['contacts']['page'],
				'pages' => $this->fdata['contacts']['pages'],
				'perpage' => $this->fdata['contacts']['perpage'],
				'total' => $this->fdata['contacts']['total'],
				);
		
		/**	----------------------------------------
		/**	 parse eeflickr:photos pair
		/**	----------------------------------------*/
			if(!$thedata)
			{
			return $TMPL->no_results();
			}
		$tagdata = $this->doPair($TMPL->tagdata,$thedata,'eeflickr:contacts_getPublicList_loop');
		
		/**	----------------------------------------
		/**	 parse eeflickr:photos_paging pair
		/**	----------------------------------------*/
		$tagdata = $this->doPair($tagdata,$pagedata,'eeflickr:contacts_getPublicList_paging');
			
		return $tagdata;
}// end exp:eeflickr:contacts_getPublicList




/*
Tag: exp:eeflickr:groups_getInfo
method: flickr.groups.getInfo
*/	
function groups_getInfo(){
		global $LOC, $TMPL, $FNS, $DSP;
		$tagdata = "";
		$this->method = "flickr.groups.getInfo";
		
		/**	----------------------------------------
		/**	 get data from flickr REST
		/**	----------------------------------------*/
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$TMPL->tagparams)));
			// fail if flickr is not ok with what you asked for 
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}
           
		/**	----------------------------------------
		/**	 prep Flickr Data
		/**	----------------------------------------*/	
			  $thedata = array();
					foreach($this->fdata['group'] as $key => $value)
						{
							// make a few extra tags for cleaned text
							if($key == "description")
							{
							   $thedata["description_alt"] = $this->alttext($value);
							   $thedata["description_clean"] = $this->cleantext($value);
							   $thedata["description_br"] = nl2br($value);
							}
							if($key == "name")
							{
							 $thedata["url_name"] = str_replace(" ", "_", $value);
							}
						$thedata[$key] = $value;
						}

		/**	----------------------------------------
		/**	 parse single vars
		/**	----------------------------------------*/	
		  $tagdata = $this->doSingle($TMPL->tagdata,$thedata);
			
	return $tagdata;
}// end exp:eeflickr:groups_getInfo


/*
Tag: exp:eeflickr:groups_pools_getContext
method: flickr.groups.pools.getContext
*/	
function groups_pools_getContext(){
		global $LOC, $TMPL, $FNS, $DSP;
		$tagdata = "";
		$this->method = "flickr.groups.pools.getContext";
		
		/**	----------------------------------------
		/**	 get data from flickr REST
		/**	----------------------------------------*/
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$TMPL->tagparams)));
			// fail if flickr is not ok with what you asked for 
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}

		/**	----------------------------------------
		/**	 prep Flickr Data
		/**	----------------------------------------*/	
			$thedata = array();
			foreach($this->fdata as $item => $array)
			{
				if(is_array($array))
					{
					foreach($array as $key => $value)
						{
						 	$thedata[$item."_".$key] = $value;
						}
				}
			}
		
		/**	----------------------------------------
		/**	 parse single vars
		/**	----------------------------------------*/	
		  $tagdata = $this->doSingle($TMPL->tagdata,$thedata);
			
	return $tagdata;
}// end exp:eeflickr:groups_pools_getContext



/*
Tag: exp:eeflickr:photos_getAllContexts
method: flickr.photos.getAllContexts
*/	
function photos_getAllContexts(){
		global $LOC, $TMPL, $FNS, $DSP;
		$tagdata = "";
		$this->method = "flickr.photos.getAllContexts";
		
		/**	----------------------------------------
		/**	 get data from flickr REST
		/**	----------------------------------------*/
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$TMPL->tagparams)));
			// fail if flickr is not ok with what you asked for 
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}


		/**	----------------------------------------
		/**	 prep Flickr Pool Data
		/**	----------------------------------------*/	
			  		$poolData = array();
					foreach($this->fdata['pool'] as $key => $value)
						{
							// make a few extra tags for cleaned text
							if($key == "title")
							{
							   $thedata["url_title"] = str_replace(" ", "_", $value);
							}
							   $thedata[$key] = $value;
						}
			
	
		/**	----------------------------------------
		/**	 parse eeflickr:AllContexts_pool_loop
		/**	----------------------------------------*/
		$tagdata = $this->doPair($TMPL->tagdata,$this->fdata['pool'],'eeflickr:AllContexts_pool');
		
		
		/**	----------------------------------------
		/**	 parse eeflickr:AllContexts_set_loop
		/**	----------------------------------------*/
		$tagdata = $this->doPair($tagdata,$this->fdata['set'],'eeflickr:AllContexts_set');
	
	return $tagdata;
}// end exp:eeflickr:photos_getAllContexts





/*
Tag: exp:eeflickr:places_getPhotosByTag
method: flickr.places.getPhotosByTag
      ** Not **
*/	
function places_getPhotosByTag(){
		global $LOC, $TMPL, $FNS, $DSP;
		$tagdata = "";
		$this->method = "flickr.places.getPhotosByTag";
		
		/**	----------------------------------------
		/**	 get data from flickr REST
		/**	----------------------------------------*/
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$TMPL->tagparams)));
			// fail if flickr is not ok with what you asked for 
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}
			
			print_r($this->fdata);


		/**	----------------------------------------
		/**	 prep Flickr Data
		/**	----------------------------------------*/	
    		// prep photo loop
			$thedata = $this->fdata['photos']['photo'];
			//print_r($thedata);
			// prep pageing data
			$pagedata['1'] = array(
				'page' => $this->fdata['photos']['page'],
				'pages' => $this->fdata['photos']['pages'],
				'perpage' => $this->fdata['photos']['perpage'],
				'total' => $this->fdata['photos']['total'],
				);
		
		/**	----------------------------------------
		/**	 parse eeflickr:photos pair
		/**	----------------------------------------*/
		$tagdata = $this->doPair($TMPL->tagdata,$thedata,'eeflickr:places_getPhotosByTag_loop');
		
		/**	----------------------------------------
		/**	 parse eeflickr:photos_paging pair
		/**	----------------------------------------*/
		$tagdata = $this->doPair($tagdata,$pagedata,'eeflickr:places_getPhotosByTag_paging');
		
		

	
	return $tagdata;
}// end exp:eeflickr:places_getPhotosByTag






/*
Tag: exp:eeflickr:auth
going to move this to the CP AT SOME POINT
*/	
function auth(){
		global $LOC, $TMPL, $FNS, $DSP, $DB;
		
  		/**	----------------------------------------
		/**	 Get API key Data 
		/**	----------------------------------------*/	
  		$query = $DB->query("SELECT * FROM exp_eeflickr_api");

		$this->api_key = ( $this->auth_token = $query->row['api_key'] ) ? $this->auth_token = $query->row['api_key']: '';
		
		$this->api_secret = ( $this->auth_token = $query->row['api_secret'] ) ? $this->auth_token = $query->row['api_secret']: '';
		
		$this->auth_token = ( $this->auth_token = $query->row['auth_token'] ) ? $this->auth_token = $query->row['auth_token']: '';

		 
		

if(!$this->api_secret){
return "You must set your API <a href=http://flickr.com/services/api/keys/{$this->api_key}/>secret</a> to use this tag";
}

//$get_frob=parse_url($_SERVER['REQUEST_URI']);
//$get_frob=explode("=",$get_frob['query']);
//$this_frob=$get_frob['frob'];

//print_r($_SERVER);

		$this_url = $_SERVER['SCRIPT_URI'];
		$arguments = "";
		$sig_arg = "";
		$perms = ( ! $TMPL->fetch_param('perms')) ? '' : $TMPL->fetch_param('perms');
		
		  $tagparams = "";
		  $tagparams['perms'] = $perms;
		  $tagparams['api_key'] = $this->api_key;
		  if(!$_POST){
		  	$tagparams['method'] = "flickr.auth.getFrob";
		  }ELSE{
		  	$tagparams['method'] = "flickr.auth.getToken";
		  }
		  $tagparams['format'] = "php_serial";


	ksort($tagparams);		  
	foreach ($tagparams as $key => $value){
		$arguments .= "".$key."=".$value."&";
		$sig_arg .= $key.$value;
	} 
		  
		$api_sig = "";
		if($this->api_secret){		
			$api_sig = "api_sig=".md5("{$this->api_secret}{$sig_arg}");
		}

		$file= $this->resturl."?".$arguments.$api_sig."";
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_Fetch($file)));





if(!$_POST){

		$frob = $this->fdata['frob'];
		$api_sig = md5("{$this->api_secret}api_key{$this->api_key}frob{$frob}perms{$perms}");
		
		$auth_url="

<div id=\"authorize\">
		<div style=\"font-weight:bold; border:1px solid #990000; padding:5px;\">
		  Warning: By setting a secret and your token in the eeFlickr CP you are basicly allowing acess to your private Pictures. Some Flickr API tags do not obey the privacy level so you will need to use sign=\"yes\" 
		</div>
	
		<br /><br />
		Click the link below to open a new window. <br />
		<b>
		<a href=\"http://flickr.com/services/auth/?api_key={$this->api_key}&perms={$perms}&frob={$frob}&api_sig={$api_sig}\" onClick=\"document.getElementById('authorize').style.display = 'none'; document.getElementById('finish').style.display = 'block';\" target=\"_blank\">Authorize</a>
        </b>
		<br />to compleate the autorization process return to this window when done
</div>
		
		<div id=\"finish\" style=\"display:none;\">
			<form action=\"{$this_url}\" method=\"post\">
				<input type=\"submit\" name=\"submit\" value=\"Complete Autorization\"/>
				<input type=\"hidden\" name=\"frob\" value=\"{$frob}\"/>
			</form>
		</div>

		";
		return $auth_url;
}ELSE{

	$arguments = "api_key={$this->api_key}&frob={$_POST['frob']}&method=flickr.auth.getToken&format=php_serial&";
	
			$api_sig = "api_sig=".md5("{$this->api_secret}api_key{$this->api_key}formatphp_serialfrob{$_POST['frob']}methodflickr.auth.getToken");
			$file= $this->resturl."?".$arguments.$api_sig."";
			
            $this->fdata = $this->clean_text_nodes(unserialize($this->F_Fetch($file)));
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}
			
			$out = "
			your token is: {$this->fdata['auth']['token']} <br />
			This gives you {$this->fdata['auth']['perms']} permission to {$this->fdata['auth']['user']['username']}'s Photos<br />			
			You will need to add your token to the eeFlickr Module in the CP
			";
			 
			return $out;
}

}// end exp:eeflickr:auth



/**	----------------------------------------
/**	 
/**
/**  Start Shared Functions
/**
/**
/**	----------------------------------------*/


/*
Tag: exp:eeflickr:paginate
Creates Pagination links and variables
*/	
function paginate(){
		global $LOC, $TMPL, $FNS, $DSP;

		$tagdata = "";
		$first_page_url = "";
		$first_page_link = "";
	    $prev_page_url = "";
		$prev_page_link = "";
		$next_page_url = "";
		$next_page_link = "";
		$last_page_url = "";
		$last_page_link = "";
		
		$max_links = ( $TMPL->fetch_param('max_links') ) ? $TMPL->fetch_param('max_links'): '4';
		$page = ( $TMPL->fetch_param('page') ) ? $TMPL->fetch_param('page'): '';
		$pages = ( $TMPL->fetch_param('pages') ) ? $TMPL->fetch_param('pages'): '';
		$perpage = ( $TMPL->fetch_param('perpage') ) ? $TMPL->fetch_param('perpage'): '';
		$total = ( $TMPL->fetch_param('total') ) ? $TMPL->fetch_param('total'): '';
		$page_word = ( $TMPL->fetch_param('page_word') ) ? $TMPL->fetch_param('page_word'): 'page';

		/**	----------------------------------------
		/**	 do current URL
		/**	----------------------------------------*/	
		$base_url = $FNS->fetch_current_uri();
		$base_url = str_replace($page_word.$page."/", "", $base_url);

		/**	----------------------------------------
		/**	 build First page URL
		/**	----------------------------------------*/	
		if($page != "1")
		{
			$first_page_url = $base_url.$page_word."1/";
		}

		/**	----------------------------------------
		/**	 build First page HREF
		/**	----------------------------------------*/	
		if($page != "1")
		{
			$first_page_link = "<a href=\"".$base_url.$page_word."1/\">&laquo; First</a>";
		}ELSE{
			$first_page_link = "&laquo; First";
		}		

		/**	----------------------------------------
		/**	 build Last page URL
		/**	----------------------------------------*/	
		if($page != $pages)
		{
			$last_page_url = $base_url.$page_word.$pages."/";
		}

		/**	----------------------------------------
		/**	 build Last page HREF
		/**	----------------------------------------*/	
		if($page != $pages)
		{
			$last_page_link = "<a href=\"".$base_url.$page_word.$pages."/\">Last &raquo;</a>";
		}ELSE{
			$last_page_link = "Last &raquo;";
		}

		/**	----------------------------------------
		/**	 build previous page URL
		/**	----------------------------------------*/	
		$prev_page = $page-1;
		if($page != '1')
		{
			$prev_page_url = $base_url.$page_word.$prev_page."/";
		}

		/**	----------------------------------------
		/**	 build previous page HREF
		/**	----------------------------------------*/	
		if($page != '1')
		{
			$prev_page_link = "<a href=\"".$base_url.$page_word.$prev_page."/\">&lt;</a>";
		}ELSE{
			$prev_page_link = "&lt;";
		}
		
		/**	----------------------------------------
		/**	 build next page URL
		/**	----------------------------------------*/	
		$next_page = $page+1;
		if($page != $pages)
		{
			$next_page_url = $base_url.$page_word.$next_page."/";
		}
		
		/**	----------------------------------------
		/**	 build next page HREF
		/**	----------------------------------------*/	
		if($page != $pages)
		{
			$next_page_link = "<a href=\"".$base_url.$page_word.$next_page."/\">&gt;</a>";
		}ELSE{
			$next_page_link = "&gt;";
		}

	    /**	----------------------------------------
		/**	 build numbered links
		/**	----------------------------------------*/	
		$output = "";
		$start = (($page - $max_links) > 0) ? $page - ($max_links - 1) : 1;
        $end   = (($page + $max_links) < $pages) ? $page + $max_links : $pages;	
		
		for ($loop = $start -1; $loop <= $end; $loop++) {
			$i = ($loop * $perpage) - $perpage;
			
			if ($base_url != '' AND $i == 0 AND REQ == 'CP') $i = '';
		
			if ($i >= 0){
				if ($page == $loop){
					$output .= '<b>'.$loop.'</b>'; // Current page
				}else{
					$output .= '<a href="'.$base_url.$page_word.$loop.'/">'.$loop.'</a>';
				}
			}
        } 

    	/**	----------------------------------------
		/**	 build final pagination output array
		/**	----------------------------------------*/	
		  $pagedata = array(
					"total_items" => $total,
					"current_page" => $page,
					"total_pages" => $pages,
					"next_page_url" => $next_page_url,
					"next_page_link" => $next_page_link,					
					"prev_page_url" => $prev_page_url,
					"prev_page_link" => $prev_page_link,
					"first_page_url" => $first_page_url,
					"first_page_link" => $first_page_link,
					"last_page_url" => $last_page_url,
					"last_page_link" => $last_page_link,
					"pagination_links" => $output,
			);
		
		/**	----------------------------------------
		/**	 parse single vars
		/**	----------------------------------------*/	
		  $tagdata = $this->doSingle($TMPL->tagdata,$pagedata);
			
	return $tagdata;
}// end exp:eeflickr:paginate



/**	----------------------------------------
/**	 generic function for Parsing single Vars
/**	----------------------------------------*/
function doSingle($tagdata,$fdata){
global $LOC, $TMPL, $FNS, $DSP;
			
			if(!$fdata)
			{
			return $tagdata;
			//return $TMPL->no_results();
			}

			foreach($fdata as $var => $res)	{
				$tagdata = $FNS->prep_conditionals($tagdata, $fdata);
					foreach($TMPL->var_single as $key => $val){
						if($var == $key){
							$tagdata = $TMPL->swap_var_single( $key, $res, $tagdata );
						}		
					}
				}
	return $tagdata;
}


function doLoop($tagdata,$fdata){
global $LOC, $TMPL, $FNS, $DSP;

			if(!$fdata)
			{
			return $tagdata;
			//return $TMPL->no_results();
			}
				
	$dimsum = "";		
		foreach($fdata as $row) {
			$tagdata = $TMPL->tagdata;
			$tagdata = $FNS->prep_conditionals($tagdata, $row);
			foreach ($TMPL->var_single as $key => $val) {
			
				if (isset($row[$val]))	{
					$tagdata = $TMPL->swap_var_single($val, $row[$val], $tagdata);
				}
			}
			$dimsum .= $tagdata;
		}
	return $dimsum;	
}





/**	----------------------------------------
/**	 generic function for Parsing Tag Pair
/**	----------------------------------------*/
function doPair($tagdata,$fdata,$pair){
	    global $LOC, $TMPL, $FNS, $DSP;
        
			if(!$fdata)
			{
			return $tagdata;
			//return $TMPL->no_results();
			}
			
			
		// output to pair
		$vp_template = $TMPL->fetch_data_between_var_pairs($TMPL->tagdata, $pair);
        $vp_output   = '';
 		foreach ($TMPL->var_pair as $key => $val)
		{
		$i=1;
				foreach($fdata as $res)	{
				$res['count'] = $i++; 
					$vp_output .= $vp_template;
					$vp_output = $FNS->prep_conditionals($vp_output, $res);
						foreach($TMPL->var_single as $key => $val)
						{
							if ( isset( $res[$key] ) )
							{
								$vp_output	= $TMPL->swap_var_single( $key, $res[$key], $vp_output );
							}								
						}
				}
            $tagdata = preg_replace("/".LD."".$pair."".RD."(.*?)".LD.SLASH."".$pair."".RD."/s", $vp_output, $tagdata, 1);
		}// end parse pair	
		return $tagdata;
}






/**	----------------------------------------
/**	 Fetch data from Flickr REST
/**	----------------------------------------*/
	function F_Fetch($file){

		if ( ! extension_loaded('curl') || ! function_exists('curl_init'))
		{
			return "plugin no curl support";
		}
	
	
		$ch = curl_init();
		curl_setopt ($ch, CURLOPT_URL, $file);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		//curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
		curl_setopt($ch, CURLOPT_TIMEOUT, 30);
		
		$file_contents = curl_exec($ch);


		// check if Flickr or curl errors
		$info = curl_getinfo($ch);
	
	    // checks if the result from flickr is what we want
		if (curl_errno($ch) || $info['http_code'] != "200" || $info['content_type'] != "text/plain; charset=utf-8") {
			$contents = "";
		} else {
			curl_close($ch);
			$contents = $file_contents;	
		}
		return $contents;  
	} // end F_Fetch


/**	----------------------------------------
/**	 Prepare the Flickr REST Data and check Cache 
/**	----------------------------------------*/
  function F_REST($method,$tagparams){
       global $DB,$SESS;

  		/**	----------------------------------------
		/**	 Get API key Data 
		/**	----------------------------------------*/	
  		$query = $DB->query("SELECT * FROM exp_eeflickr_api");

		$this->api_key = ( $this->auth_token = $query->row['api_key'] ) ? $this->auth_token = $query->row['api_key']: '';
		$this->cache_refresh = ( $this->cache_refresh = $query->row['cache_refresh'] ) ? $this->cache_refresh = $query->row['cache_refresh']: '';
		$this->cache_refresh = $this->cache_refresh*60;
		
		$sign = ( ! isset($tagparams['sign'])) ? '' : $tagparams['sign'];

			if($sign == "yes")
			{
				$this->api_secret = ( $this->api_secret = $query->row['api_secret'] ) ? $this->api_secret = $query->row['api_secret']: '';
					$this->api_secret = str_replace(" ", "", $this->api_secret);
				$this->auth_token = ( $this->auth_token = $query->row['auth_token'] ) ? $this->auth_token = $query->row['auth_token']: '';
					$this->auth_token = str_replace(" ", "", $this->auth_token);
				
			}
			ELSE
			{
				$this->api_secret = "";
				$this->auth_token = "";
			}

			$page_word = ( ! isset($tagparams['page_word'])) ? 'page' : $tagparams['page_word'];

		/**	----------------------------------------
		/**	 base Required API Arrguments 
		/**	----------------------------------------*/	
		  $tagparams['api_key'] = $this->api_key;
		  $tagparams['format'] = 'php_serial';
		  $tagparams['method'] = $method;
	  
		/**	----------------------------------------
		/**	 set the Flickr Token if provided
		/**	----------------------------------------*/
		  if($this->auth_token && $this->api_secret)
			  {
			  $tagparams['auth_token'] = $this->auth_token;
			  }

  
		/**	----------------------------------------
		/**	 sort and build out the api arguments 
		/**	 because Flickr requires alpha sort
		/**	----------------------------------------*/	 
		
		  ksort($tagparams);
		  $arguments = "";
		  $sig_arg = "";
		  
				foreach ($tagparams as $key => $value)
					{
					$skip = "";
					
						if($key == "sign")
						{
							$skip = "1";
						}
					
						if($key == "cache")
						{
							$skip = "1";
						}
						
						if($key == "refresh")
						{
						$value = $value*60;
							$this->cache_refresh = $value;
							$skip = "1";
						}
					    
						if($key == "page")
						{
						$value = str_replace($page_word, "", $value);
						}
						

						if(!$skip){
							$arguments .= "&".$key."=".$value;
							$sig_arg .= $key.$value;
						}
					}

		/**	----------------------------------------
		/**	 build API Sig if we need it 
		/**	----------------------------------------*/	
		$api_sig = "";
		if($this->auth_token && $this->api_secret){		
			$api_sig = "&api_sig=".md5("{$this->api_secret}{$sig_arg}");
		}
	    
		$cache = new RESTCache(PATH_CACHE.''.$this->cache_path.'', $this->cache_refresh);
		$file= $this->resturl."?".$arguments.$api_sig; 
		
		/**	----------------------------------------
		/**	 check Cache Status
		/**	----------------------------------------*/
		$cache_status = $cache->check_cache($file);
		

		/**	----------------------------------------
		/**	 cache is good just return it
		/**	----------------------------------------*/
		if ( $cache_status == 'HIT' )
		 {
			$contents = $cache->get($file);
			return $contents;
		}
		
		/**	----------------------------------------
		/**	 cache has expired check if new flickr is ok
		/**	----------------------------------------*/
		if ( $cache_status == 'STALE' )
		 {			
			// get data from flickr
			$contents = $this->F_Fetch($file);
			// build array from searialized flickr REST data
		    $cache_check = $this->clean_text_nodes(unserialize($contents));

				/**	----------------------------------------
				/**	 if Flickr returns a OK cache the data and return it
				/**  else return the stale data because its better than nothing
				/**	----------------------------------------*/			
				if($cache_check['stat'] == "ok")
				{
					$cache->set($file, $contents);
					return $contents;
				}
				ELSE
				{
					$contents = $cache->get($file);
					return $contents;
				}			
		}
			
		/**	----------------------------------------
		/**	 default fetch to flickr if all else failes
		/**	----------------------------------------*/
        $contents = $this->F_Fetch($file);
		$cache->set($file, $contents);
		return $contents;  
	} // end F_REST





		/**	----------------------------------------
		/**	 add no follow to links
		/**	----------------------------------------*/
			function rel_nofollow( $text ) {
				$text = preg_replace('|<a(.+?)>|i', '<a$1 rel="nofollow">', $text);
				return $text;
			 }

		/**	----------------------------------------
		/**	 hammer out arrays
		/**	----------------------------------------*/
			function clean_text_nodes($arr) {
				if (!is_array($arr)) {
					return $arr;
				} elseif (count($arr) == 0) {
					return $arr;
				} elseif (count($arr) == 1 && array_key_exists('_content', $arr)) {
					return $arr['_content'];
				} else {
					foreach ($arr as $key => $element) {
						$arr[$key] = $this->clean_text_nodes($element);
					}
					return($arr);
				}
			}	

		/**	----------------------------------------
		/**	 count the number of times an item is in an array
		/**	----------------------------------------*/
			function array_count_values_multidim($a,$out=false) {
			  if ($out===false) $out=array();
			  if (is_array($a)) {
			   foreach($a as $e)
				 $out=$this->array_count_values_multidim($e,$out);
			  }
			  else {
			   if (array_key_exists($a,$out))
				 $out[$a]++;
			   else
				 $out[$a]=1;
			  }
			  return $out;
			} 
			
			
		/**	----------------------------------------
		/**	 removes all html with the exception of the bold tag
		/**	----------------------------------------*/
		 function cleantext( $text ) {
			$alttext = $this->reverse_htmlentities($text);
			$alttext = strip_tags($alttext, '<b>');
			$alttext = str_replace("\n", " ", $alttext);
			$alttext = str_replace("Fairhope", "<b>Fairhope</b>", $alttext);
			return $alttext;
		 }
 
 
 		/**	----------------------------------------
		/**	 convert askii encoded html back to true html
		/**	----------------------------------------*/
		function reverse_htmlentities($mixed)
		 {
		   $htmltable = get_html_translation_table(HTML_ENTITIES);
			  foreach($htmltable as $key => $value) {
				$mixed = ereg_replace(addslashes($value),$key,$mixed);
			  }
				return $mixed;
		  }
 
 		/**	----------------------------------------
		/**	 convert askii encoded html back to true html
		/**	----------------------------------------*/
		function alttext( $text ) {
			$alttext = $this->reverse_htmlentities($text);
			$alttext = strip_tags($alttext);
			$alttext = str_replace("\n", " ", $alttext);
			$alttext = str_replace("\"", "", $alttext);
			$alttext = str_replace("&", "&amp;", $alttext);
			return $alttext;
		 }


/*
Tag: exp:eeflickr:tags_getListUserPopular
*/	
function tags_FullTag(){
		global $LOC, $TMPL, $FNS, $DSP;
		$tagdata = "";
		$this->method = "flickr.photos.search";
		
		$user_id = ( $TMPL->fetch_param('user_id') ) ? $TMPL->fetch_param('user_id'): '';
		$cow['user_id'] = $user_id;
		
		$per_page = ( $TMPL->fetch_param('per_page') ) ? $TMPL->fetch_param('per_page'): '';
		$cow['per_page'] = $per_page;
		
		$page = ( $TMPL->fetch_param('page') ) ? $TMPL->fetch_param('page'): '';
		$cow['page'] = $page;
		
		$tags = ( $TMPL->fetch_param('tags') ) ? $TMPL->fetch_param('tags'): '';
		$cow['tags'] = $tags;
		
		$refresh = ( $TMPL->fetch_param('refresh') ) ? $TMPL->fetch_param('refresh'): '';
		$cow['refresh'] = $refresh;
		
		$privacy_filter = ( $TMPL->fetch_param('privacy_filter') ) ? $TMPL->fetch_param('privacy_filter'): '';
		$cow['privacy_filter'] = $privacy_filter;
		
		$api_sort  = ( $TMPL->fetch_param('api_sort') ) ? $TMPL->fetch_param('api_sort'): '';
		$cow['api_sort'] = $api_sort;
			
		$sort = ( $TMPL->fetch_param('sort') ) ? $TMPL->fetch_param('sort'): 'alpha-desc';
		
		$min_size = ( $TMPL->fetch_param('min_size') ) ? $TMPL->fetch_param('min_size'): '8';
		
		$max_size = ( $TMPL->fetch_param('max_size') ) ? $TMPL->fetch_param('max_size'): '24';
		
		$color_offset = ( $TMPL->fetch_param('color_offset') ) ? $TMPL->fetch_param('color_offset'): '20';
				
		$mincount = ( $TMPL->fetch_param('mincount') ) ? $TMPL->fetch_param('mincount'): '2';
		
		$ignore = ( $TMPL->fetch_param('ignore') ) ? $TMPL->fetch_param('ignore'): '';
		/**	----------------------------------------
		/**	 get data from flickr REST
		/**	----------------------------------------*/
		
		
		$this->fdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$cow)));
			// fail if flickr is not ok with what you asked for 
			if($this->fdata['stat'] != "ok")
			{
				return $this->fdata['message'];
			}
			

		/**	----------------------------------------
		/**	 prep Flickr Data
		/**	----------------------------------------*/		
		$this->method = "flickr.tags.getListPhoto";	
		$i=0;
		foreach($this->fdata['photos']['photo'] as $photo){
			$param['photo_id'] = $photo['id'];
			$tagdata = $this->clean_text_nodes(unserialize($this->F_REST($this->method,$param)));
				foreach ($tagdata['photo']['tags']['tag'] as $tag)
				{
					 $taggather[$i] = array(
							"tag" => $tag['raw'],
						);
				$i++;
				}
		}
		$tagscounted=$this->array_count_values_multidim($taggather);

     	/**	----------------------------------------
		/**	 Prep the Ignored Tags List
		/**	----------------------------------------*/
		$ignore = str_replace("&#47;", "/", $ignore);
			if($ignore){
				$tagstoignore = explode("|",$ignore);
			}ELSE{
				$tagstoignore[] = "";
			}
			
		/**	----------------------------------------
		/**	 Prep sorting options
		/**	----------------------------------------*/
  		$tags_max = max($tagscounted);

			// sort options
			if($sort === "count-desc"){arsort($tagscounted);}
			if($sort === "count-asc"){asort($tagscounted);}
			if($sort === "alpha-desc"){ksort($tagscounted);}
			if($sort === "alpha-asc"){krsort($tagscounted);}

		/**	----------------------------------------
		/**	 Prep for Out
		/**	----------------------------------------*/
		$thedata = array();	 
			foreach ($tagscounted as $key => $value)
			 {				
					if (! in_array($key, $tagstoignore) && $value > $mincount)
					 {
					$font_size = ($max_size-$min_size)*(sqrt($value/$tags_max))+$min_size;
					
					$font_color = 255-ceil((255-$color_offset)*(sqrt($value/$tags_max))+$color_offset);
					$color_low = 255 - $font_color;
					
							$tagLink = str_replace('/', '^', $key);
							$tagLink = str_replace(' ', '_', $tagLink);
							
							$www = "www";
							//if($tagLink == "Fairhope_Alabama"){
							//$www = "fairhope";
							//}
							//if($tagLink == "Alabama"){
							//$www = "alabama";
							//}
							//if($tagLink == "Mobile_Alabama"){
							//$www = "mobile";
							//}
					
							$thedata[] = array(
								"tag" => $key,
								"lumis_url" => $tagLink,
								"www_url" => $www,
								"tag_count" => $value,
								"font_size" => $font_size,
								"color_low"=>$color_low,
								"color_hi"=>$font_color,
							 );
					}
			}

		
		/**	----------------------------------------
		/**	 parse single vars
		/**	----------------------------------------*/	
		  $tagdata = $this->doLoop($TMPL->tagdata,$thedata);
			
	return $tagdata;
}// end exp:eeflickr:tags_FullTag


/*
exp:eeflickr:tagcloudraw
*/	
function tagcloudraw(){
		global $LOC, $TMPL, $FNS, $DSP;
		$method		= "flickr.people.getPublicPhotos";
		
		// gather the options
		$this->cache_refresh = ( $TMPL->fetch_param('refresh') ) ? $TMPL->fetch_param('refresh'): $this->cache_refresh;
		
		$user_id = ( ! $TMPL->fetch_param('user_id')) ? '' : $TMPL->fetch_param('user_id');
			if ($user_id == ""){return "you must supply a user_id=\"\"";}
		
		$per_page = ( ! $TMPL->fetch_param('photos')) ? '' : $TMPL->fetch_param('photos');
		
		$sort = ( ! $TMPL->fetch_param('sort')) ? '' : $TMPL->fetch_param('sort');
		
		$min_size = ( ! $TMPL->fetch_param('min_size')) ? '' : $TMPL->fetch_param('min_size');
		
		$max_size = ( ! $TMPL->fetch_param('max_size')) ? '' : $TMPL->fetch_param('max_size');
		
		$color_offset = ( ! $TMPL->fetch_param('color_offset')) ? '' : $TMPL->fetch_param('color_offset');
				
		$mincount = ( ! $TMPL->fetch_param('mincount')) ? '' : $TMPL->fetch_param('mincount');
		
		$ignore = ( ! $TMPL->fetch_param('ignore')) ? '' : $TMPL->fetch_param('ignore');
		$ignore = str_replace("&#47;", "/", "$ignore");
			if($ignore){$tagstoignore = explode("|",$ignore);}ELSE{$tagstoignore[] = "";}
		
		$arguments="user_id={$user_id}&per_page={$per_page}&extras=tags,raw_tags";

		 
		// fetch rest data
		$fdata = $this->clean_text_nodes(unserialize($this->flickr_REST($method,$arguments,$this->cache_refresh)));

		
		if($fdata['stat'] != "ok"){
			return $fdata['message'];
		}
		$photodata = $fdata['photos']['photo'];
		
		foreach($photodata as $photo){
			//if($photo['tags']){
				$argument="photo_id={$photo['id']}";
				$tdata = $this->clean_text_nodes(unserialize($this->flickr_REST('flickr.tags.getListPhoto',$argument,$this->cache_refresh)));
				foreach($tdata['photo']['tags']['tag'] as $tag){
					$taggather[] = array(
						"tag" => $tag['raw'],
					);
				}
			//}
		}
	// 	
	$tagscounted=$this->array_count_values_multidim($taggather);
	$tags_max = max($tagscounted);

	// sort options
	if($sort === "count-desc"){arsort($tagscounted);}
	if($sort === "count-asc"){asort($tagscounted);}
	if($sort === "alpha-desc"){ksort($tagscounted);}
	if($sort === "alpha-asc"){krsort($tagscounted);}


foreach ($tagscounted as $key => $value) {
	 
		if (! in_array($key, $tagstoignore) && $value > $mincount) {
		$font_size = ($max_size-$min_size)*(sqrt($value/$tags_max))+$min_size;
		
		$font_color = 255-ceil((255-$color_offset)*(sqrt($value/$tags_max))+$color_offset);
		$color_low = 255 - $font_color;
    	
		
			$tagLink = str_replace('/', '^', $key);
			$tagLink = str_replace(' ', '_', $tagLink);
			
				$showTag[] = array(
					"tag" => $key,
					"url_tag" => urlencode($key),
					"tag_count" => $value,
					"font_size" => $font_size,
					"lumis_link" => $tagLink,
					"color_low"=>$color_low,
					"color_hi"=>$font_color,
				 );
		}

}

		// end Flickr stuff now send it to EE
		
	$dimsum = "";		
		foreach($showTag as $row) {
			$tagdata = $TMPL->tagdata;
			$tagdata = $FNS->prep_conditionals($tagdata, $row);
			foreach ($TMPL->var_single as $key => $val) {
				if (isset($row[$val]))	{
					$tagdata = $TMPL->swap_var_single($val, $row[$val], $tagdata);
				}
			}
			$dimsum .= $tagdata;
		}
	return $dimsum;	
}// end function tagcloudraw()

 
    
}// end eeflickr Class




/*
* Taken from the Magpie RSS Script 
* Credit 
 * Author:      Kellan Elliott-McCrea <kellan@protest.net>
 * Version:		0.51
 * License:		GPL
 */
class RESTCache {
	var $BASE_CACHE = './cache';	// where the cache files are stored
	var $MAX_AGE	= 3600;  		// when are files stale, default one hour
	var $ERROR 		= "";			// accumulate error messages
	
	
	function RESTCache ($base='', $age='') {
		if ( $base ) {
			$this->BASE_CACHE = $base;
		}
		if ( $age ) {
			$this->MAX_AGE = $age;
		}
		
		// attempt to make the cache directory
		if ( ! file_exists( $this->BASE_CACHE ) ) {
			$status = @mkdir( $this->BASE_CACHE, 0755 );
			@chmod($this->BASE_CACHE, 0777);
			
			// if make failed 
			if ( ! $status ) {
				$this->error(
					"Cache couldn't make dir '" . $this->BASE_CACHE . "'."
				);
			}
		}
		else
		{
			// EE - Make sure cache is 777
			@chmod($this->BASE_CACHE, 0777);
		}
	}
	
/*=======================================================================*\
	Function:	set
	Purpose:	add an item to the cache, keyed on url
	Input:		url from wich the rss file was fetched
	Output:		true on sucess	
\*=======================================================================*/
	function set ($url, $rss) {
		$this->ERROR = "";
		
		$cache_file = $this->file_name( $url );
		//unlink($cache_file);
		
		$fp = @fopen( $cache_file, 'w' );
		
		if ( ! $fp ) {
			$this->error(
				"Cache unable to open file for writing: $cache_file"
			);
			return 0;
		}
		
		
		$data = serialize( $rss );
		fwrite( $fp, $data );
		fclose( $fp );

		
		@chmod($cache_file, 0777);
		
		return $cache_file;
	}
	
/*=======================================================================*\
	Function:	get
	Purpose:	fetch an item from the cache
	Input:		url from wich the rss file was fetched
	Output:		cached object on HIT, false on MISS	
\*=======================================================================*/	
	function get ($url) {
		$this->ERROR = "";
		$cache_file = $this->file_name( $url );
		
		if ( ! file_exists( $cache_file ) ) {
			$this->debug( 
				"Cache doesn't contain: $url (cache file: $cache_file)"
			);
			return 0;
		}
		
		$fp = @fopen($cache_file, 'r');
		if ( ! $fp ) {
			$this->error(
				"Failed to open cache file for reading: $cache_file"
			);
			return 0;
		}
		
		if (($file_size = filesize($cache_file)) == 0)
		{
			return 0;
		}
		
		$data = fread( $fp, $file_size );
		$rss = unserialize( $data );
		
		@chmod($cache_file, 0777);
		
		return $rss;
	}

/*=======================================================================*\
	Function:	check_cache
	Purpose:	check a url for membership in the cache
				and whether the object is older then MAX_AGE (ie. STALE)
	Input:		url from wich the rss file was fetched
	Output:		cached object on HIT, false on MISS	
\*=======================================================================*/		
	function check_cache ( $url ) {
		$this->ERROR = "";
		$filename = $this->file_name( $url );
		
		if ( file_exists( $filename ) ) {
			// find how long ago the file was added to the cache
			// and whether that is longer then MAX_AGE
			$mtime = filemtime( $filename );
			$age = time() - $mtime;
			if ( $this->MAX_AGE > $age ) {
				// object exists and is current
				return 'HIT';
			}
			else {
				// object exists but is old
				return 'STALE';
			}
		}
		else {
			// object does not exist
			return 'MISS';
		}
	}


	
/*=======================================================================*\
	Function:	file_name
	Purpose:	map url to location in cache
	Input:		url from wich the rss file was fetched
	Output:		a file name
\*=======================================================================*/		
	function file_name ($url)
	{
		global $FNS;

		$filename = md5( $url );
		$filename = $filename.".xml";
		
		return $FNS->remove_double_slashes(join( DIRECTORY_SEPARATOR, array( $this->BASE_CACHE, $filename)));
	}

/*=======================================================================*\
	Function:	error
	Purpose:	register error
\*=======================================================================*/			
	function error ($errormsg, $lvl=E_USER_WARNING) {
		// append PHP's error message if track_errors enabled
		if ( isset($php_errormsg) ) { 
			$errormsg .= " ($php_errormsg)";
		}
		$this->ERROR = $errormsg;
		if ( MAGPIE_DEBUG ) {
			trigger_error( $errormsg, $lvl);
		}
		else {
			error_log( $errormsg, 0);
		}
	}
	
	function debug ($debugmsg, $lvl=E_USER_NOTICE) {
		if ( MAGPIE_DEBUG ) {
			$this->error("MagpieRSS [debug] $debugmsg", $lvl);
		}
	}

}

?>
