<?php

/*
=============================================================
	ExpressionEngine - by pMachine
-------------------------------------------------------------
	http://www.pmachine.com/
-------------------------------------------------------------
	Copyright (c) 2003 - 2004 pMachine, Inc.
=============================================================
	THIS IS COPYRIGHTED SOFTWARE
	PLEASE READ THE LICENSE AGREEMENT
	http://www.pmachine.com/expressionengine/license.html
=============================================================
	File:		pi.flickr_tools.php
-------------------------------------------------------------
	Version:	1.0
-------------------------------------------------------------
	Purpose:	Grab images from your Flickr account
=============================================================
	This module was developed by Weston Renoud and
	Solspace.com and is based on code created by the pMachine
	team.
	If you would like to make a $10 donation towards the
	support and growth of this module, please send via PayPal
	to support@solspace.com.
	Solspace welcomes your feedback on this module. Please
	send queries to support@solspace.com.

	USE THIS SOFTWARE AT YOUR OWN RISK. SOLSPACE ASSUMES
	NO WARRANTY OR LIABILITY FOR THIS SOFTWARE AS DETAILED
	IN THE PMACHINE LICENSE AGREEMENT.
=============================================================
*/


$plugin_info = array(
						'pi_name'			=> 'Flickr_tools',
						'pi_version'		=> '1.0',
						'pi_author'			=> 'Weston Renoud, Mitchell Kimbrough',
						'pi_author_url'		=> 'http://www.solspace.com/software',
						'pi_description'	=> 'Grab images from your Flickr account',
						'pi_usage'			=> Flickr_tools::usage()
					);


class Flickr_tools {

    var $return_data;
    
	//	Constants
	var $api_key	= '7731358c5b719c65247b0307b88bd398';
	var $endpoint	= "http://www.flickr.com/services/rest/";
	var $method		= "flickr.groups.pools.getPhotos";
    
    // ----------------------------------------
    //  Get Recent
    // ----------------------------------------

	function get_recent()
	{
		global $LOC, $TMPL, $FNS;
		
		$photos		= array();
		$temp		= array();
		
		$group_id	= ( $TMPL->fetch_param('group_id') ) ? $TMPL->fetch_param('group_id'): ''; 
		$limit		= ( $TMPL->fetch_param('limit') ) ? $TMPL->fetch_param('limit'): '5';
		
		//	Check for group id
		if ( $group_id == '' )
		{
			return false;
		}		 
		
		if ( ! $photos = $this->flickr_xml2php($this->method,"group_id=$group_id&per_page=$limit") )
		{
			return false;
		}
		
		// ----------------------------------------
		//   Filter non-photos out of $photos
		// ----------------------------------------
		foreach ( $photos as $photo )
		{			
			if ($photo['tag'] == "PHOTO")
			{
				$temp[]	= $photo;
			}
		}
		
		$photos	= $temp;
		
		if (count($photos) == 0)
		{
			return $TMPL->no_results;
		}
		//	End filter non-photos

		// ----------------------------------------
		//   Loop through the results
		// ----------------------------------------
		foreach($photos as $photo)
		{
			$tagdata	= $TMPL->tagdata;
			
			//	Set photo attributes
			$id			= $photo['attributes']['ID'];
			$owner		= $photo['attributes']['OWNER'];
			$secret		= $photo['attributes']['SECRET'];
			$server		= $photo['attributes']['SERVER'];
			$title		= $photo['attributes']['TITLE'];
			$is_public	= $photo['attributes']['ISPUBLIC'];
			$is_friend	= $photo['attributes']['ISFRIEND'];
			$is_family	= $photo['attributes']['ISFAMILY'];
			$owner_name	= $photo['attributes']['OWNERNAME'];
			$date_added	= $photo['attributes']['DATEADDED'];
			$date_added	= date("M d, Y", $date_added);
 
			// ----------------------------------------
			//   Parse "single" variables
			// ----------------------------------------	
			foreach ($TMPL->var_single as $var)
			{
				// ----------------------------------------
				//  Parse image_link
				// ----------------------------------------
				if ($var == 'image_link')
				{					
					$tagdata	= $TMPL->swap_var_single($var, 'http://www.flickr.com/photos/'.$owner.SLASH.$id, $tagdata);                
				}
				
				// ----------------------------------------
				//  Parse image_url
				// ----------------------------------------
				if ($var == 'image_url')
				{
					$tagdata	= $TMPL->swap_var_single($var, 'http://static.flickr.com'.SLASH.$server.SLASH.$id.'_'.$secret.'_s.jpg', $tagdata);                
				}
				
				// ----------------------------------------
				//  Parse image_title
				// ----------------------------------------
				if ($var == 'image_title')
				{
					$tagdata	= $TMPL->swap_var_single($var, $title, $tagdata);                
				}
				
				// ----------------------------------------
				//  Parse owner_name
				// ----------------------------------------
				if ($var == 'owner_name')
				{
					$tagdata	= $TMPL->swap_var_single($var, $owner_name, $tagdata);                
				}
				
				// ----------------------------------------
				//  Parse date_added
				// ----------------------------------------
				if ($var == 'date_added')
				{
					$tagdata	= $TMPL->swap_var_single($var, $date_added, $tagdata);                
				}
				
				// ----------------------------------------
				//  Parse width
				// ----------------------------------------
				if ($var == 'width')
				{
					$tagdata	= $TMPL->swap_var_single($var, '75', $tagdata); 
				}
				
				// ----------------------------------------
				//  Parse height
				// ----------------------------------------
				if ($var == 'height')
				{
					$tagdata	= $TMPL->swap_var_single($var, '75', $tagdata); 
				}            
		
				// ----------------------------------------
				//  parse {switch} variable
				// ----------------------------------------					
				if (ereg("^switch", $var))
				{
					$sparam = $FNS->assign_parameters($var);
					
					$sw = '';

					if (isset($sparam['switch']))
					{
						$sopt = explode("|", $sparam['switch']);
						
						if (count($sopt) == 2)
						{
							if (isset($switch[$sparam['switch']]) AND $switch[$sparam['switch']] == $sopt['0'])
							{
								$switch[$sparam['switch']] = $sopt['1'];
								
								$sw = $sopt['1'];									
							}
							else
							{
								$switch[$sparam['switch']] = $sopt['0'];
								
								$sw = $sopt['0'];									
							}
						}
					}
					
					$tagdata = $TMPL->swap_var_single($var, $sw, $tagdata);
				}
				//	End parse switch
			}				
			//	End parse single
		
			$this->return_data	.= $tagdata;
		}
		//	End loop through the results
		
		return $this->return_data;
	}

	//	End get recent

    // ----------------------------------------
    //  flickr_xml2php()
    // ----------------------------------------

	function flickr_xml2php($method,$arguments)
	{		
		$file		= "$this->endpoint?api_key=$this->api_key&method=$method&$arguments"; 
		
		$xml_parser = xml_parser_create();
		
		if ( ! ($fp = fopen($file, "r")) )
		{ 
			return false;
		}
		
		$contents	= ''; 
		$string		= fread($fp, 5000);
		
		while ($string)
		{ 
			$contents	.= $string; 
			$string		= fread($fp, 5000); 
		} 
		fclose($fp); 
		xml_parse_into_struct($xml_parser, $contents, $arr_vals); 
		xml_parser_free($xml_parser); 
		
		return $arr_vals; 
	}
	
	//	End flickr_xml2php()
	
    
	// -------------------------------------------------
	//  Plugin Usage
	// -------------------------------------------------
	//	This function describes how the plugin is used.
	//  Make sure and use output buffering.
	// -------------------------------------------------
	
	function usage()
	{
		ob_start(); 
?>
		This plugin allows you to show thumbnail images from your Flickr gallery.
		
		_____
		The Tag
		{exp:flickr_tools:get_recent group_id="77777777@N00" limit="10"}
		{/exp:flickr_tools:get_recent}
		
		
		_____
		Parameters
		group_id: This is the ID of your flickr group. It is a required parameter.
		limit: This limits the number of thumbnails that will be returned. The default is 5.
		
		
		_____
		Variables
		image_url: URL of the thumbnail image.
		
		image_link: URL of the Flickr gallery where the image is housed.
		
		image_title: Title of the image in the Flickr gallery.
		
		owner_name: Owner of the image.
		
		date_added: Date the image was added to the gallery. In version 1 of this plugin, the date format is fixed. (Jan 1, 2001).
		
		switch: Use the switch variable here as you would use it throughout ExpressionEngine.

		if no_results: Use this conditional to show content when there are no images available.
		
		
		_____
		Example
		
		Recent Flickr Images<br />
		
		<table>
		{exp:flickr_tools:get_recent group_id="77777777@N00" limit="10"}
		{if no_results}<tr><td>There were no images to show.</td></tr>{/if}
		<tr class="{switch="rowOn|rowOff"}">
		<td>
		<a target="flickr" href="{image_link}"><img src="{image_url}" width="{width}" height="{height}" title="{image_title}" border="0" /></a>
		</td>
		<td>
		{image_title}<br />
		{owner_name}
		</td>
		</tr>
		{/exp:flickr_tools:get_recent}
		</table>
		
<?php
		$buffer = ob_get_contents();
			
		ob_end_clean(); 
		
		return $buffer;
	}
	// END


}
// END CLASS
?>