{embed="includes/header" page_title="Waiting Children"}

<!-- ============== -->
<!-- = BEGIN MAIN = -->
<!-- ============== -->
	<div id="main">
		{embed="includes/search"}
		<div id="sidebar">
			{exp:weblog:categories weblog="children" class="countries" id="countries" show="not 4|5" show_empty="no" arrange="alphabetical" cache="yes" refresh="60"}			
				<a href="{path=/adoption/country}">{category_name}</a>
			{/exp:weblog:categories}
		</div>
	
		<h2 id="pageheader">{exp:weblog:category_heading}{category_name}{/exp:weblog:category_heading}</h2>
		
		<div id="breadcrumbs">
			<a href="{path=/}">Home</a>&nbsp;&nbsp;:&nbsp;&nbsp;<a href="{path=/adoption/purpose}">Adoption</a>&nbsp;&nbsp;:&nbsp;&nbsp;<a href="{path=/adoption/waiting}">Waiting Children</a>&nbsp;&nbsp;:&nbsp;&nbsp;<a href="#">{exp:weblog:category_heading}{category_name}{/exp:weblog:category_heading}</a>
		</div>
		<div id="content_main">
			<div id="main_text">
				
				{if segment_4 == "haiti"}
					<p><!-- TYPE A CUSTOM MESSAGE BELOW -->
					The situation in Haiti, which began with the earthquake last January and has been exacerbated by the cholera epidemic, continues to be grave for all orphans there. The political unrest unfolding in Port au Prince is threatening to make things even worse. As a result, we consider all orphans in Haiti to fall within the category of special-needs or difficult-to-place, so we will be listing any of them on our Web site that we can—even those who might otherwise not fit within our normal criteria for listing. Please pray for all of the people of Haiti, and especially for the orphans.
					</p><br />
				{/if}
								{if segment_4 == "east_asia"}
					<p><!-- TYPE A CUSTOM MESSAGE BELOW -->
					<b>Special Note:</b> The requirements for listing children from East Asia have changed dramatically over the last few years, and especially over the last several months. In most instances we are not allowed to post photos of the waiting children, we are not allowed to indicate the actual country the child is from, and as of very recently, we are in some cases not allowed to indicate the child's special need. All of these restrictions make it more difficult for a family to determine whether or not they might be interested in pursuing the adoption of any given child, or even whether or not they might need to request additional information. We are permitted to provide additional information upon inquiry, but not until asked specifically. Please bear in mind, as you look at the list of children here, that each and every one of them is a real child, created in God's image and needing a family. Pray for these children, as we do, and pray that God would lead you as you seek guidance in choosing a child to adopt, or in asking for additional information about waiting children. 
					</p><br />
				{/if}
				
			<table cellspacing="0" cellpadding="0" id="t_waiting">
<tr><th colspan="3">Click on a child below to learn more.</th></tr>
			{exp:weblog:entries weblog="children" search:adopt_status="Pending|Completed|Waiting|Removed" show_expired="no" cache="yes" refresh="30"}
			
			
			{if no_results}
				<tr><td colspan="3"><em>There are currently no children listed for this region.</em></td></tr>
			{/if}
			{if notice != 'None'}
				<tr><td colspan="3" class="notice"><p>{notice}</p></td></tr>
			{/if}
				<tr>
					<td class="t_pic">
					{if show_pic != 'No'}
					{exp:eeflickr:photos_search user_id="23102619@N05" tags="{entry_id},before" tag_mode="all" sign="yes" refresh="1"}
{if no_results}<a href="{permalink="adoption/child"}"><img src="/img/nopic_small.gif" alt="no picture" /></a>{/if}
						{eeflickr:photos_search_loop}
						<a href="{permalink="adoption/child"}"><img src="https://farm{farm}.static.flickr.com/{server}/{id}_{secret}_t.jpg" alt="" /></a>
						{/eeflickr:photos_search_loop}
					{/exp:eeflickr:photos_search}
					{if:else}
						<a href="{permalink="adoption/child"}"><img src="/img/nopic_small.gif" alt="no picture" /></a>
					{/if}
					</td>
					<td class="t_info">
						<p class="name"><a href="{permalink="adoption/child"}">{if show_name == 'Yes'}{title}{if:else}Name(s) Undisclosed{/if}</a></p>
						<p class="dob"><strong>Birthdate:</strong> {dob}</p>
						<p class="gender"><strong>Gender:</strong> {gender}</p>
						<!-- Displays the child's TSC Id for volunteers -->
						{if logged_in}
						<p class="id"><strong>ID:</strong> TSC_{entry_id}</p>
						{/if}
						<p class="needs"><strong>Special need(s):</strong><br />{needs}</p>
					</td>
					<td class="t_links">
						<ul>
							<li class="btn_pcard"><a href="{permalink=/adoption/prayer_card}" target="_blank">Print a Prayer Card</a></li>
							<li class="form_sponsor">
								<form action="{path=/donate/now}" method="post">
									<input type="hidden" name="sponsor_id" value="{entry_id}">
									<input type="image" class="btn_sponsor sponsor_off" src="/img/btn_donate_trans.gif" name="sponsor" alt="Sponsor">
								</form>
							</li>
							<li class="btn_moreinfo"><a href="{permalink="adoption/child"}">More Information</a></li>
						</ul>
					</td>
				</tr>
			{/exp:weblog:entries}
			</table>
			
			<p class="top_link"><a href="#">back to top</a></p>
			</div>
			
			<div id="loading_text" class="hidden">
				<p>Please wait while the data loads<img src="{site_url}img/country-loader.gif" border="0" alt=""></p>
			</div>
		</div>
	</div>
	<div id="footer_main"></div>
	
</div>

{embed="includes/footer" page_title="about"}

</div>
</body>
</html>